<?php
function ShowIncomPMList(){
  if ($GLOBALS['islogged']){ //если юзер залогинен берём его настройки отображения контента

    $stmt = mysqli_prepare($GLOBALS['DB'], "SELECT timezone, timeformat, tpp FROM users WHERE iduser=? LIMIT 1");
    mysqli_stmt_bind_param($stmt, "i", intval($_COOKIE['iduser'])); //это безопасно поскольку islogged
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $timezone, $timeformat, $tpp);
    mysqli_stmt_fetch($stmt);
    mysqli_stmt_close($stmt);

    $stmt = mysqli_prepare($GLOBALS['DB'], "SELECT id_pm FROM pm WHERE id_to=? AND pm.isdelete_to=0"); //подсчитываем входящие личные сообщения
    mysqli_stmt_bind_param($stmt, "i", $_COOKIE['iduser']);
    mysqli_stmt_execute($stmt);
    mysqli_stmt_store_result($stmt);
    $TotalMessages = mysqli_stmt_num_rows($stmt);
    mysqli_stmt_close($stmt);

    if ($TotalMessages > 0){
      $page = $_GET['page'];
      if ($page <= 0) $page = 1;   
      $TotalPages = ceil($TotalMessages / $tpp); //максимальный номер страницы = кол-во страниц
      if ($page > $TotalPages) $page = $TotalPages;
      if ($page == $TotalPages){ //если страница единственная или последняя - вычисляем длину списка писем
        $ShowMessages = $TotalMessages - (($TotalPages - 1) * $tpp);
      }else{ // если страница внутри итератора - длина списка равна настроечной
        $ShowMessages = $tpp;
      }
      $Offset = $tpp * ($page - 1);
      
      $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT pm.id_pm, pm.id_from, pm.sendtime, pm.topic, pm.isread, users.name
      FROM pm LEFT JOIN users ON pm.id_from = users.iduser WHERE pm.id_to=? AND pm.isdelete_to=0
      ORDER BY pm.sendtime DESC LIMIT '."$ShowMessages".' OFFSET '."$Offset"); //берём входящие личные сообщения, сортируя в порядке от свежих к старым
      mysqli_stmt_bind_param($stmt, "i", intval($_COOKIE['iduser']));
      mysqli_stmt_execute($stmt);
      mysqli_stmt_bind_result($stmt, $id_pm, $id_from, $sendtime, $topic, $isread, $name);

      $html = '<table width="100%" style="background-color: #f5f5f5; font-size: 16px; font-weight: 600"><tr><td height="2px"></td></tr>
      <tr><td><div align="center">Входящие личные сообщения</div></td></tr><tr><td></td></tr></table>'; //заголовок страницы

      if ($TotalPages > 1){ //показываем итератор, только если страниц 2 и более
        require 'PageIteratorCreate.php';
        $PageIterator = PageIteratorCreate(27, $TotalPages, $page, './?ai=22&page='); //создаём html-код итератора страниц  
        $UpperPageIterator = '<table cellpadding="0" cellspacing="0"><tr>{iterator}</tr><tr><td height="6px"></td></tr></table>';    
        $UpperPageIterator = str_replace('{iterator}', $PageIterator, $UpperPageIterator);   
      }else $UpperPageIterator='';

      $html .= $UpperPageIterator.
      '<form action="./deletepm.php?mode=0" onsubmit="if(!confirm('."'Вы уверены, что хотите удалить выбранные сообщения?'".')) return false" method="post">
      <table width="100%" cellspacing="1" cellpadding="3" style="background-color: #ffffff" border="0">
      <tr style="background-color: #d2d2d2; text-align: left; font-size: 14px; font-weight: 600">
      <td width="22%">Отправитель</td>
      <td width="61%">Тема</td>
      <td width="15%">Отправлено</td>
      <td width="2%"><input class="smallcheckbox" type="checkbox" title="Выбрать все" onclick="invertAll(this, this.form);"></td>
      <script>function invertAll(oInvertCheckbox, oForm){for (var i = 0; i < oForm.length; i++){oForm[i].checked = oInvertCheckbox.checked;}}</script></tr>';
	   
      //шаблон строки таблицы
      $template = '<tr class="{class}"><td><div><a style="display: block" href="./?ai=50&id={id_from}">{name}</a></div></td>
      <td><div><a href="./?ai=23&id={id_m}">{topic}</a></div></td><td><div>{date}</div></td>
      <td align="center"><div><input class="smallcheckbox" type="checkbox" name="chb{id_m}"></div></td></tr>';

      while (mysqli_stmt_fetch($stmt)){
        $row = $template; //копируем шаблон строки

        if ($isread == 0){$row = str_replace('{class}','CellsNewPost', $row);}
        else {$row = str_replace('{class}','CellsOldPost', $row);}
        $row = str_replace('{id_from}',$id_from, $row);
        $row = str_replace('{name}',$name, $row);
        $row = str_replace('{id_m}',$id_pm, $row);
        if (empty($topic)) $topic = '(без темы)';
        $row = str_replace('{topic}',$topic, $row);

        $date = date_create($sendtime); //для отображения смещаем время на указанное в настройках количество часов
        if ($timezone < 0){
          $timeshift = abs($timezone);
          date_sub($date, date_interval_create_from_date_string("$timeshift".' hours'));
        }else{
          date_add($date, date_interval_create_from_date_string("$timezone".' hours'));
        }
        $sendtime = date_format($date, $timeformat);
        $row = str_replace('{date}',$sendtime, $row);

        $html .= $row; 
      }
      mysqli_stmt_close($stmt);

      $LowerPageIterator='<table cellpadding="0" cellspacing="0" width="100%"><tr>
      <td width="92%"><table cellpadding="0" cellspacing="0"><tr><td height="6px"></td></tr><tr>{iterator}</tr></table></td><td width="2%">      
      <input style="opacity: 0.7" onMouseOut="this.style.opacity=0.7" onMouseOver="this.style.opacity=1"
      type="image" src="./pics/delete.png" alt="Del" title="Удалить выбранные сообщения"></td></tr></table></form>';
      
      if ($TotalPages > 1){ //показываем итератор, только если страниц 2 и более
        $LowerPageIterator = str_replace('{iterator}', $PageIterator, $LowerPageIterator);
      }else{
        $LowerPageIterator = str_replace('{iterator}', '', $LowerPageIterator);   
      } 
      $html .= '</table>'.$LowerPageIterator;

      return $html;
      exit();
    }else{ //если входящих сообщений нет
      $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
      <tr><td><div align="center">У Вас нет входящих личных сообщений.</div></td></tr><tr><td height="10px"></td></tr></table>';  
      return $html; 
      exit();
    }
  }else{ //если юзер не залогинен
    $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
    <tr><td><div align="center">Авторизуйтесь, чтобы просматривать личные сообщения.</div></td></tr><tr><td height="10px"></td></tr></table>';  
    return $html; //не используем сообщения ai=200 чтобы после авторизации вернуться на ту же страницу
  }
}
?>