<?php
function ShowTopicsList(){
  if ($GLOBALS['islogged']){ //если юзер залогинен берём его настройки отображения контента и статус
    $stmt = mysqli_prepare($GLOBALS['DB'], "SELECT timezone, timeformat, tpp, mpp, status FROM users WHERE iduser=? LIMIT 1");
    mysqli_stmt_bind_param($stmt, 'i', intval($_COOKIE['iduser'])); 
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $timezone, $timeformat, $tpp, $mpp, $userstatus);
    mysqli_stmt_fetch($stmt);
    mysqli_stmt_close($stmt);
  }else{ // если гостевой доступ
    $timezone = (int)$_COOKIE['timeshift']; // пробуем взять данные из куков
    $tpp = (int)$_COOKIE['tpp'];
    $mpp = (int)$_COOKIE['mpp'];
    if (($tpp < 1) or ($tpp > 16777215)) $tpp = 20;
    if (($mpp < 1) or ($mpp > 16777215)) $mpp = 20;
    if (($timezone < -12) or ($timezone > 12)) $timezone = 0;
    $timeformat = 'H:i d.m.Y';
    $userstatus = 'guest'; //используем эту перемнную для условного обозначения гостей
  }

  $sorting = (int)$_COOKIE['sorting']; //критерий сортировки берём из куков
  if ($sorting < 0) $sorting = 0;
  if ($sorting > 6) $sorting = 6;
  $sortvars = array('по последнему сообщению','по дате создания топика','по автору топика','по количеству постов','по количеству просмотров','по количеству лайков','по названию топика');
  $options = '';
  for ($i = 0; $i<=(count($sortvars)-1); $i++){
    if ($i == $sorting) $options .= '<option value="'.$i.'" selected>'.$sortvars[$i].'</option>'."\n"; 
    else $options .= '<option value="'.$i.'">'.$sortvars[$i].'</option>'."\n";
  }
  $sortcolor = 'background:#FFFF9A;';
  switch ($sorting){
    case 1:
      $criterion = 'topics.id_topic ASC';
      break;
    case 2:
      $criterion = 'b1.name ASC';
      break;
    case 3:
      $criterion = 'topics.msgs DESC';
      break;    
    case 4:
      $criterion = 'topics.views DESC';
      break;
    case 5:
      $criterion = 'topics.likes DESC';
      break;
    case 6:
      $criterion = 'topics.name ASC';
      break;  
    default:
      $criterion = 'topics.lasttime DESC';
      $sortcolor = ''; //при пункте по умолчанию не подсвечиваем выпадающий список
  }

  if ($userstatus == 'guest'){ //если участник не залогинен
    $query = mysqli_query($GLOBALS['DB'], 'SELECT COUNT(*) FROM topics WHERE deleted=0');//подсчитываем общее количество неудалённых топиков
    $i = mysqli_fetch_row($query);
    $TotalTopics = $i[0];

    if ($TotalTopics > 0){
      $page = $_GET['page'];
      if ($page <= 0) $page = 1; 
      $TotalPages = ceil($TotalTopics / $tpp); //максимальный номер страницы = кол-во страниц
      if ($page > $TotalPages) $page = $TotalPages;
      if ($page == $TotalPages){ //если страница единственная или последняя - вычисляем длину списка топиков
        $ShowTopics = $TotalTopics - (($TotalPages - 1) * $tpp);
      }else{ // если страница внутри итератора - длина списка равна настроечной
        $ShowTopics = $tpp;
      }
      $Offset = $tpp * ($page - 1);

      $stmt = mysqli_prepare($GLOBALS['DB'],
      'SELECT topics.id_topic, topics.type, topics.id_author, topics.name, topics.id_lastuser, topics.lasttime, topics.id_lastmsg,
       topics.msgs, topics.views, topics.likes, b1.name, b2.name
       FROM topics
       LEFT JOIN users AS b1 ON topics.id_author = b1.iduser
       LEFT JOIN users AS b2 ON topics.id_lastuser = b2.iduser
       WHERE topics.deleted=0
       ORDER BY '.$criterion.' LIMIT '."$ShowTopics".' OFFSET '."$Offset"); //берём все топики, сортируя по заданному критерию
      mysqli_stmt_execute($stmt);
      mysqli_stmt_bind_result($stmt, $id_topic, $type, $id_author, $name, $id_lastuser, $lasttime, $id_lastmsg, $msgs, $views, $likes, $authname, $lastname);

      if ($TotalPages > 1){ //создаём итератор, только если страниц 2 и более
        require 'PageIteratorCreate.php';
        $PageIterator = PageIteratorCreate(23, $TotalPages, $page, './?page='); //создаём html-код итератора страниц (ячейки таблицы) 
      }else $PageIterator = '';

      $html = '<table cellspacing="0" cellpadding="0" border="0">
      <tr style="vertical-align: middle"><td width="607px"><table cellspacing="0" cellpadding="0" border="0"><tr>'.$PageIterator.'</tr></table></td>
      <td><select id="sorting" title="Сортировка" style="'.$sortcolor.'border-width:0px;font-size:14px;padding-top:2px;padding-bottom:2px;padding-left:1px;padding-right:1px">'.$options.'</select>
      <script>sorting.onchange=function(){var data="ai=101"+"&sort="+encodeURIComponent(document.getElementById("sorting").value);AsyncAct(data);}</script>
      </td></tr><tr><td height="2px"></td></tr></table>
      <table width="100%" cellspacing="1" cellpadding="3" style="background-color: #ffffff" border="0">
      <tr style="background-color: #d2d2d2; text-align: left; font-size: 14px; font-weight: 600">
      <td width="3%" align="middle"><img src="./pics/status.png" alt="Тип" title="Тип топика"></td>
      <td width="47%">Название топика</td>
      <td width="13%">Автор</td>
      <td width="7%" align="middle">Посты</td>
      <td width="7%" align="middle">Лайки</td>
      <td width="10%" align="middle">Смотры</td>
      <td width="13%" align="middle">Последнее</td></tr>';  //верх (кнопка + итератор) и заголовок таблицы
     
      //шаблон строки таблицы
      $template = '<tr class="{class}">
      <td align="middle"><div>{type}</div></td>
      <td><div><a href="./?ai=9&id={id_topic}" target="_blank">{name}</a>{smallpgi}</div></td>
      <td><a title="Перейти на страницу участника" href="./?ai=50&id={id}">{authname}</a></td>
      <td><div style="text-align:center">{msgs}</div></td>
      <td><div style="text-align:center">{likes}</div></td>
      <td><div style="text-align:center">{views}</div></td>
      <td><div style="font-size: 12px"><a title="Посмотреть сообщение" href="./?ai=9&id={id_topic}&msg={id_lastmsg}#{id_lastmsg}">{lasttime}<br>{lastname}</a></div></td>
      </tr>';

      while (mysqli_stmt_fetch($stmt)){
        $row = $template; //копируем шаблон строки
  
        if ($_COOKIE['lastvisit'] < $lasttime) $row = str_replace('{class}','CellsNewPost', $row);
        else $row = str_replace('{class}','CellsOldPost', $row); //подсвечиваем топики, в которых сообщения появились после последнего визита (по кукам)

        switch ($type){ //два типа топиков 1 - обычный, 2 - закрытый
          case 1: 
            $row = str_replace('{type}','<img src="./pics/common.png" alt="common" title="Обычный">', $row);
            break;
          case 2: 
            $row = str_replace('{type}','<img src="./pics/lock.png" alt="closed" title="Закрытый">', $row);
        }

        $TotalMsgPages = ceil($msgs / $mpp); //узнаём нужно ли показывать маленький пейджитератор в названии топика
        if ($TotalMsgPages > 1){
          if ($TotalMsgPages < 5){ //если рисуем всё
            $smallpgi = ' (';
            for ($i = 1; $i <= $TotalMsgPages; $i++){
              if ($i < $TotalMsgPages){
                $smallpgi .= '<a href="./?ai=9&id={id_topic}&page='.$i.'" target="_blank">'.$i.'</a>, ';
              }else{
                $smallpgi .= '<a href="./?ai=9&id={id_topic}&page='.$i.'" target="_blank">'.$i.'</a>)';
              }
            }
          }else{//если ставим разрыв из троеточия
            $smallpgi = ' (<a href="./?ai=9&id={id_topic}&page=1">1</a>…';
            for ($i = $TotalMsgPages - 2; $i <= $TotalMsgPages; $i++){
              if ($i < $TotalMsgPages){
                $smallpgi .= '<a href="./?ai=9&id={id_topic}&page='.$i.'" target="_blank">'.$i.'</a>, ';
              }else{
                $smallpgi .= '<a href="./?ai=9&id={id_topic}&page='.$i.'" target="_blank">'.$i.'</a>)';
              }
            }
          }
        }else{
          $smallpgi = '';
        }
   
        $row = str_replace('{smallpgi}', $smallpgi, $row);
        $row = str_replace('{id_topic}', $id_topic, $row);        
        $row = str_replace('{id}', $id_author, $row);        
        $row = str_replace('{msgs}', $msgs, $row);
        $row = str_replace('{likes}', $likes, $row);
        $row = str_replace('{views}', $views, $row);
        $row = str_replace('{id_last}', $id_lastuser, $row);
        $row = str_replace('{id_lastmsg}', $id_lastmsg, $row);
        $row = str_replace('{lastname}', $lastname, $row);

        $date = date_create($lasttime); //для отображения смещаем время на указанное в куках количество часов
        if ($timezone < 0){
          $timeshift = abs($timezone);
          date_sub($date, date_interval_create_from_date_string("$timeshift".' hours'));
        }else{
          date_add($date, date_interval_create_from_date_string("$timezone".' hours'));
        }
        $lasttime = date_format($date, $timeformat);
        $row = str_replace('{lasttime}', $lasttime, $row);

        $row = str_replace('{authname}', $authname, $row);        
        $row = str_replace('{name}', $name, $row);

        $html .= $row;
      }
      mysqli_stmt_close($stmt);

      $html .= '</table>
      <table cellspacing="0" cellpadding="0"><tr><td height="2px"></td></tr><tr>'.$PageIterator.'</tr></table>'; //низ списка топиков

    }else{ //если топиков нет
      $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
      <tr><td><div align="center">На форуме нет топиков.</div></td></tr><tr><td height="10px"></td></tr></table>';
    }
  }else{ //если участник залогинен
    $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT id_to FROM wblist WHERE id_from=? AND listid=-1');
    mysqli_stmt_bind_param($stmt, 'i', intval($_COOKIE['iduser']));
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $id_to);
    mysqli_stmt_store_result($stmt);
    $num = mysqli_stmt_num_rows($stmt);
    if ($num == 0){
      $bl = '';
    }else{
      $bl = ' AND id_author NOT IN('; //"чёрный" список строим один раз и потом отправляем в следующий запрос как константу
      while (mysqli_stmt_fetch($stmt)){
        $num = $num - 1;
        if ($num > 0) $bl .= "$id_to".',';
        else $bl .= "$id_to".') '; //последний элемент завершаем скобкой а не запятой
      }
    }
    mysqli_stmt_close($stmt);

    $query = mysqli_query($GLOBALS['DB'], 'SELECT COUNT(*) FROM topics WHERE deleted=0'.$bl);//подсчитываем общее количество топиков с учётом игнора
    $i = mysqli_fetch_row($query);
    $TotalTopics = $i[0]; 

    if ($TotalTopics > 0){
      $page = $_GET['page'];
      if ($page <= 0) $page = 1; 
      $TotalPages = ceil($TotalTopics / $tpp); //максимальный номер страницы = кол-во страниц
      if ($page > $TotalPages) $page = $TotalPages;
      if ($page == $TotalPages){ //если страница единственная или последняя - вычисляем длину списка топиков
        $ShowTopics = $TotalTopics - (($TotalPages - 1) * $tpp);
      }else{ // если страница внутри итератора - длина списка равна настроечной
        $ShowTopics = $tpp;
      }
      $Offset = $tpp * ($page - 1);

      $stmt = mysqli_prepare($GLOBALS['DB'],
      'SELECT topics.id_topic, topics.type, topics.id_author, topics.name, topics.id_lastuser, topics.lasttime, topics.id_lastmsg,
       topics.msgs, topics.views, topics.likes, b1.name, b2.name, t1.id_item
       FROM topics
       LEFT JOIN users AS b1 ON topics.id_author = b1.iduser
       LEFT JOIN users AS b2 ON topics.id_lastuser = b2.iduser
       LEFT JOIN newmsgs AS t1 ON topics.id_topic = t1.id_topic AND t1.iduser=?
       WHERE topics.deleted=0'.$bl.'
       ORDER BY '.$criterion.' LIMIT '."$ShowTopics".' OFFSET '."$Offset"); //берём все топики, сортируя по заданному критерию
      mysqli_stmt_bind_param($stmt, 'i', intval($_COOKIE['iduser'])); 
      mysqli_stmt_execute($stmt);
      mysqli_stmt_bind_result($stmt, $id_topic, $type, $id_author, $name, $id_lastuser, $lasttime, $id_lastmsg, $msgs, $views, $likes, $authname, $lastname, $isread);
  
      if ($TotalPages > 1){ //показываем итератор, только если страниц 2 и более
        require 'PageIteratorCreate.php';
        $PageIterator = PageIteratorCreate(19, $TotalPages, $page, './?page='); //создаём html-код итератора страниц  
      }else $PageIterator='';

      if ($userstatus == 'create'){ //если участник имеет право создавать топики показываем ему кнопку
        $newtopicbut = '<td><a class="noneall" href="./?ai=8"><img style="vertical-align: middle" src="./pics/newtopic.png" alt="Создать топик"></a></td><td width="6px"></td>';
        $width = '482';
      }else{
        $newtopicbut = '';
        $width = '607'; //разница из-за ширины кнопки
      }

      $html = '<table cellspacing="0" cellpadding="0" border="0">
      <tr style="vertical-align: middle">'.$newtopicbut.'<td width="'.$width.'px"><table cellspacing="0" cellpadding="0" border="0"><tr>'.$PageIterator.'</tr></table></td>
      <td><select id="sorting" title="Сортировка" style="'.$sortcolor.'border-width:0px;font-size:14px;padding-top:2px;padding-bottom:2px;padding-left:1px;padding-right:1px">'.$options.'</select>
      <script>sorting.onchange=function(){var data="ai=101"+"&sort="+encodeURIComponent(document.getElementById("sorting").value);AsyncAct(data);}</script>
      </td></tr>
      <tr><td height="2px"></td></tr></table>
      <table width="100%" cellspacing="1" cellpadding="3" style="background-color: #ffffff" border="0">
      <tr style="background-color: #d2d2d2; text-align: left; font-size: 14px; font-weight: 600; height: 27px">
      <td width="3%" align="middle">
      <img style="vertical-align: middle; cursor: pointer" onclick="UnMarkAll()" src="./pics/status.png" alt="Тип" title="Тип топика / пометить все прочитанными"></td>
      <td width="47%">Название топика</td>
      <td width="13%">Автор</td>
      <td width="7%" align="middle">Посты</td>
      <td width="7%" align="middle">Лайки</td>
      <td width="10%" align="middle">Смотры</td>
      <td width="13%" align="middle">Последнее</td></tr>';  //заголовок таблицы
     
      //шаблон строки таблицы
      $template = '<tr id="T{id_topic}" class="{class}">
      <td align="middle"><div>{type}</div></td>
      <td><div><a href="./?ai=9&id={id_topic}">{name}</a>{smallpgi}</div></td>
      <td><a title="Перейти на страницу участника" href="./?ai=50&id={id}">{authname}</a></td>
      <td><div style="text-align:center">{msgs}</div></td>
      <td><div style="text-align:center">{likes}</div></td>
      <td><div style="text-align:center">{views}</div></td>
      <td><div style="font-size: 12px"><a title="Посмотреть сообщение" href="./?ai=9&id={id_topic}&msg={id_lastmsg}#{id_lastmsg}">{lasttime}<br>{lastname}</a></div></td>
      </tr>';

      while (mysqli_stmt_fetch($stmt)){
        $row = $template; //копируем шаблон строки
  
        if ($isread > 0) $row = str_replace('{class}','CellsNewPost', $row);
        else $row = str_replace('{class}','CellsOldPost', $row);

        switch ($type){ //два типа топиков 1 - обычный, 2 - закрытый
          case 1: 
            $row = str_replace('{type}','<img src="./pics/common.png" alt="common" style="cursor:pointer" onclick="InvertMark({id_topic})" title="Обычный">', $row);
            break;
          case 2: 
            $row = str_replace('{type}','<img src="./pics/lock.png" alt="closed" style="cursor:pointer" onclick="InvertMark({id_topic})" title="Закрытый">', $row);
        }   
   
        $TotalMsgPages = ceil($msgs / $mpp); //узнаём нужно ли показывать маленький пейджитератор в названии топика
        if ($TotalMsgPages > 1){
          if ($TotalMsgPages < 5){ //если рисуем всё
            $smallpgi = ' (';
            for ($i = 1; $i <= $TotalMsgPages; $i++){
              if ($i < $TotalMsgPages){
                $smallpgi .= '<a href="./?ai=9&id={id_topic}&page='.$i.'">'.$i.'</a>, ';
              }else{
                $smallpgi .= '<a href="./?ai=9&id={id_topic}&page='.$i.'">'.$i.'</a>)';
              }
            }
          }else{//если ставим разрыв из троеточия
            $smallpgi = ' (<a href="./?ai=9&id={id_topic}&page=1">1</a>…';
            for ($i = $TotalMsgPages - 2; $i <= $TotalMsgPages; $i++){
              if ($i < $TotalMsgPages){
                $smallpgi .= '<a href="./?ai=9&id={id_topic}&page='.$i.'">'.$i.'</a>, ';
              }else{
                $smallpgi .= '<a href="./?ai=9&id={id_topic}&page='.$i.'">'.$i.'</a>)';
              }
            }
          }
        }else{
          $smallpgi = '';
        }
   
        $row = str_replace('{smallpgi}', $smallpgi, $row);
        $row = str_replace('{id_topic}', $id_topic, $row);
        $row = str_replace('{id}', $id_author, $row);
        $row = str_replace('{msgs}', $msgs, $row);
        $row = str_replace('{likes}', $likes, $row);
        $row = str_replace('{views}', $views, $row);
        $row = str_replace('{id_last}', $id_lastuser, $row);
        $row = str_replace('{id_lastmsg}', $id_lastmsg, $row);
        $row = str_replace('{lastname}', $lastname, $row);

        $date = date_create($lasttime); //для отображения смещаем время на указанное в настройках количество часов
        if ($timezone < 0){
          $timeshift = abs($timezone);
          date_sub($date, date_interval_create_from_date_string("$timeshift".' hours'));
        }else{
          date_add($date, date_interval_create_from_date_string("$timezone".' hours'));
        }
        $lasttime = date_format($date, $timeformat);
        $row = str_replace('{lasttime}', $lasttime, $row);

        $row = str_replace('{authname}', $authname, $row);
        $row = str_replace('{name}', $name, $row);
  
        $html .= $row;
      }
      mysqli_stmt_close($stmt);

      $html .= '</table><table cellspacing="0" cellpadding="0"><tr><td height="2px"></td></tr><tr>'.$newtopicbut.$PageIterator.'</tr></table>'.
      '<script>function InvertMark(id_topic){AsyncAct("ai=11&id="+encodeURIComponent(id_topic));}
      function UnMarkAll(){AsyncAct("ai=13");}</script>'; // низ списка

    }else{ //если топиков нет
      $newtopicbut = '<td><a class="noneall" href="./?ai=8"><img style="vertical-align: middle" src="./pics/newtopic.png" alt="Создать топик"></a></td><td width="7px"></td>';
      $html = '<table cellspacing="0" cellpadding="0"><tr style="vertical-align: middle">'.$newtopicbut.'</tr><tr><td height="3px"></td></tr></table>
      <table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
      <tr><td><div align="center">На форуме нет топиков.</div></td></tr><tr><td height="10px"></td></tr></table>
      <table cellspacing="0" cellpadding="0"><tr style="vertical-align: middle">'.$newtopicbut.'</tr><tr><td height="3px"></td></tr></table>';  
    }
  }
  return $html;
}
?>