<?php
function ShowUserInfo($id){
  $id = substr($id, 0, 5); 

  $stmt = mysqli_prepare($GLOBALS['DB'], "SELECT name, about, avatar, topics, posts, status, deleted, showonline, regtime, timevisit
   FROM users WHERE iduser=? LIMIT 1");
  mysqli_stmt_bind_param($stmt, 'i', $id);
  mysqli_stmt_execute($stmt);
  mysqli_stmt_bind_result($stmt, $name, $about, $avatar, $topics, $posts, $status, $deleted, $showonline, $regtime, $timevisit);
  mysqli_stmt_fetch($stmt);
  mysqli_stmt_close($stmt);

  if (!$deleted and !empty($name)){

    $_SESSION['User_Name'] = $name;

    $html = file_get_contents('./templates/UserInfoForm.html');

    if ($GLOBALS['islogged']){ //если юзер залогинен берём его настройки отображения контента
      $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT timezone, timeformat FROM users WHERE iduser=? LIMIT 1');
      mysqli_stmt_bind_param($stmt, 'i', intval($_COOKIE['iduser']));
      mysqli_stmt_execute($stmt);
      mysqli_stmt_bind_result($stmt, $timezone, $timeformat);
      mysqli_stmt_fetch($stmt);
      mysqli_stmt_close($stmt);
      }else{ // если гостевой доступ
        $timezone = (int)$_COOKIE['timeshift']; // пробуем взять данные из куков
        if (($timezone < -12) or ($timezone > 12)) $timezone = 0;
        $timeformat = 'H:i d.m.Y';
      }

    $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT COUNT(*) FROM claims WHERE id_from=?'); //всего жалоб подано участником
    mysqli_stmt_bind_param($stmt, 'i', intval($id));
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $totalclaimsfrom);
    mysqli_stmt_fetch($stmt);
    mysqli_stmt_close($stmt);

    $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT COUNT(*) FROM claims WHERE id_to=? AND type=1'); //всего жалоб подано на участника
    mysqli_stmt_bind_param($stmt, 'i', intval($id));
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $totalclaimsto);
    mysqli_stmt_fetch($stmt);
    mysqli_stmt_close($stmt);

    $temp = '<span style="color: blue" title="От участника">'.$totalclaimsfrom.
      '</span> / <span  style="color: red" title="На участника">'.$totalclaimsto.'</span>';
    $html = str_replace('{claims}', $temp, $html);

    $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT likes FROM posts WHERE id_author=? AND deleted=0'); //подсчитываем лайки в неудалённых
    mysqli_stmt_bind_param($stmt, 'i', intval($id));
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $likes);
    $totalikes = 0;
    while (mysqli_stmt_fetch($stmt)){
      $totalikes = $totalikes + $likes;
    }
    mysqli_stmt_close($stmt);

    $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT disagrees FROM posts WHERE id_author=? AND deleted=0'); //подсчитываем дизлайки в неудалённых
    mysqli_stmt_bind_param($stmt, 'i', intval($id));
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $disagrees);
    $totaldisagrees = 0;
    while (mysqli_stmt_fetch($stmt)){
      $totaldisagrees = $totaldisagrees + $disagrees;
    }
    mysqli_stmt_close($stmt);

    $temp = '<span style="color: blue" title="Лайков">'.$totalikes.
      '</span> / <span  style="color: red" title="Дизлайков">'.$totaldisagrees.'</span>';
    $html = str_replace('{likes}', $temp, $html);

    if ($_COOKIE['iduser'] == $id){
      $c = '';
      $pm = '';
      $wb = '';
      $in = '';
    }else{
      $stmt = mysqli_prepare($GLOBALS['DB'], "SELECT listid FROM wblist WHERE id_from=? AND id_to=? LIMIT 1"); //проверяем ч/б список
      mysqli_stmt_bind_param($stmt, 'ii', intval($_COOKIE['iduser']), $id);
      mysqli_stmt_execute($stmt);
      mysqli_stmt_bind_result($stmt, $listid);
      mysqli_stmt_fetch($stmt);
      mysqli_stmt_close($stmt); 

      $c = '<a class="noneall" tabindex="0" onkeypress="this.click()" style="cursor: pointer" onclick="openForm(1,'."'{name}'".
      ',{id})"><img title="Подать жалобу на участника" src="./pics/claim.png" alt="Жалоба"></a>';
      $pm = '<a class="noneall" href="./?ai=20&id={id}"><img title="Написать личное сообщение" src="./pics/pm.png" alt="Личное сообщение"></a>';

      $wb = '<select id="wblist" style="font-size: 15px; padding: 1px">{options}</select> списке';
      $options = ''; //заполняем опции чёрно/белого списка
      $var = array( 1 => 'белом', 0 => 'обычном',-1 => 'чёрном');
      for ($i = 1; $i >= -1; $i-- ){
        if ($i == $listid) $options .= '<option value="'.$i.'" selected>'.$var[$i].'</option>'."\n"; //"обычном" = 0 по умолчанию
        else $options .= '<option value="'.$i.'">'.$var[$i].'</option>'."\n";
      }
      $wb = str_replace('{options}', $options, $wb);
      $in = 'В ';
    }
    $html = str_replace('{claim}', $c, $html);
    $html = str_replace('{pm}', $pm, $html);
    $html = str_replace('{wblist}', $wb, $html);
    $html = str_replace('{in}', $in, $html);

    if (!empty($avatar)) //если аватар есть - выводим его
    $html = str_replace('{avatar}','<div style="margin-top:1px;margin-left:-5px;"><img src="./avatars/'.$avatar.'.jpg" alt="Аватар" title="Аватар участника"></div>', $html); 
    else $html = str_replace('{avatar}','', $html); 

    $html = str_replace('{name}', $name, $html);
    require 'TagFormat.php';
    $html = str_replace('{about}', TagFormat($about), $html);
    $html = str_replace('{topics}', $topics, $html);
    $html = str_replace('{posts}', $posts, $html);
    $html = str_replace('{status}', $status, $html);
    $html = str_replace('{id}', $id, $html);

    $nowtime = strtotime(date("Y-m-d H:i:s")); //берём текущее время и преобразуем в метку времени Unix
    $daysonforum = round(($nowtime - strtotime($regtime))/86400, 0, PHP_ROUND_HALF_UP); //сколько дней прошло с регистрации
    if ($daysonforum == 0) $daysonforum = 1;
    $lastdigit = (int)(substr("$daysonforum", -1)); //последняя цифра
    $prelastdigit = (int)(substr("$daysonforum", -2, 1)); //предпоследняя цифра
    if (($daysonforum != 11) and ($lastdigit == 1)){ // в конце 1 кроме 11 - день
        $days = 'день';
    }elseif (($prelastdigit == 1) or ($lastdigit == 0)){ //от 10 до 20 - дней
        $days = 'дней';
    }elseif (($lastdigit > 1) and ((int)$lastdigit < 5)){ 
        $days = 'дня';
    }else{
        $days = 'дней';
    };
    $html = str_replace('{timefromreg}',' '.$daysonforum.' '.$days, $html);

    if ($showonline == 1){ //если пользователь разрешил в настройках показ своего онлайн-статуса
        $lastvisit = strtotime($timevisit);
        if (($nowtime-$lastvisit)>300){ //если пользователь загружал страницы форума 5 минут назад - полагаем, что он оффлайн
          $html = str_replace('{online}','<div><img src="./pics/offline.png" alt="offline" title="Участник оффлайн"></a>', $html); 
        }else{ // иначе - онлайн
          $html = str_replace('{online}','<div><img src="./pics/online.png" alt="online" title="Участник онлайн"></a>', $html); 
        }
    
        $date = date_create($timevisit); //для отображения смещаем время на указанное в настройках количество часов
        if ($timezone < 0){
          $timeshift = abs($timezone);
          date_sub($date, date_interval_create_from_date_string("$timeshift".' hours'));
        }else{
          date_add($date, date_interval_create_from_date_string("$timezone".' hours'));
        }
        $timevisit = date_format($date, $timeformat);
    
      }else{
        $timevisit = 'недоступно';
        $html = str_replace('{online}','<div><img src="./pics/na.png" alt="NA" title="Онлайн-статус недоступен"></a>', $html); 
      }  
      $html = str_replace('{lastvisit}',' '.$timevisit, $html);


    }else{
        $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
        <tr><td><div align="center">Такого участника нет.</div></td></tr><tr><td height="10px"></td></tr></table>';
    }

  return $html;
}
?>