<?php
function ShowUserTopics(){
  $id = substr($_GET['id'], 0, 5); // id участника

  $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT name, topics, deleted FROM users WHERE iduser=? LIMIT 1');
  mysqli_stmt_bind_param($stmt, 'i', $id);
  mysqli_stmt_execute($stmt);
  mysqli_stmt_bind_result($stmt, $authname, $TotalTopics, $deleted);
  mysqli_stmt_fetch($stmt);
  mysqli_stmt_close($stmt);

  if (!$deleted and !empty($authname)){ //если такой участник есть

    if ($TotalTopics > 0){

      if ($GLOBALS['islogged']){ //если юзер залогинен берём его настройки отображения контента
        $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT timezone, timeformat, tpp, mpp FROM users WHERE iduser=? LIMIT 1');
        mysqli_stmt_bind_param($stmt, 'i', intval($_COOKIE['iduser'])); 
        mysqli_stmt_execute($stmt);
        mysqli_stmt_bind_result($stmt, $timezone, $timeformat, $tpp, $mpp);
        mysqli_stmt_fetch($stmt);
        mysqli_stmt_close($stmt);
      }else{ // если гостевой доступ
        $timezone = (int)$_COOKIE['timeshift']; // пробуем взять данные из куков
        $tpp = (int)$_COOKIE['tpp'];
        $mpp = (int)$_COOKIE['mpp'];
        if (($tpp < 1) or ($tpp > 16777215)) $tpp = 20;
        if (($mpp < 1) or ($mpp > 16777215)) $mpp = 20;
        if (($timezone < -12) or ($timezone > 12)) $timezone = 0;
        $timeformat = 'H:i d.m.Y';
      }

      $page = $_GET['page'];
      if ($page <= 0) $page = 1; 
      $TotalPages = ceil($TotalTopics / $tpp); //максимальный номер страницы = кол-во страниц
      if ($page > $TotalPages) $page = $TotalPages;
      if ($page == $TotalPages){ //если страница единственная или последняя - вычисляем длину списка топиков
        $ShowTopics = $TotalTopics - (($TotalPages - 1) * $tpp);
      }else{ // если страница внутри итератора - длина списка равна настроечной
        $ShowTopics = $tpp;
      }
      $Offset = $tpp * ($page - 1);
  
      $html = '<table width="100%" style="background-color: #f5f5f5; font-size: 16px; font-weight: 600"><tr><td height="2px"></td></tr>
      <tr><td><div align="center">Топики участника "'.$authname.'"</div></td></tr><tr><td></td></tr></table>'; //заголовок страницы

      if ($TotalPages > 1){ //показываем итератор, только если страниц 2 и более
        require 'PageIteratorCreate.php';
        $PageIterator = PageIteratorCreate(25, $TotalPages, $page, './?ai=52&id='.$id.'&page='); //создаём html-код итератора страниц  
      }else $PageIterator='';

      $html .= '<table cellspacing="0" cellpadding="0"><tr style="vertical-align: middle">'.$PageIterator.'</tr><tr><td height="3px"></td></tr></table>
      <table width="100%" cellspacing="1" cellpadding="3" style="background-color: #ffffff" border="0">
      <tr style="background-color: #d2d2d2; text-align: left; font-size: 14px; font-weight: 600">
      <td width="3%" align="middle"><img src="./pics/status.png" alt="Тип" title="Тип топика"></td>
      <td width="47%">Название топика</td>
      <td width="13%">Автор</td>
      <td width="7%" align="middle">Посты</td>
      <td width="7%" align="middle">Лайки</td>
      <td width="10%" align="middle">Смотры</td>
      <td width="13%" align="middle">Последнее</td></tr>';  //заголовок таблицы
     
      //шаблон строки таблицы
      $template = '<tr id="T{id_topic}" class="{class}">
      <td align="middle"><div>{type}</div></td>
      <td><div><a href="./?ai=9&id={id_topic}">{name}</a>{smallpgi}</div></td>
      <td><a title="Перейти на страницу участника" href="./?ai=50&id={id}">{authname}</a></td>
      <td><div style="text-align:center">{msgs}</div></td>
      <td><div style="text-align:center">{likes}</div></td>
      <td><div style="text-align:center">{views}</div></td>
      <td><div style="font-size: 12px"><a title="Посмотреть сообщение" href="./?ai=9&id={id_topic}&msg={id_lastmsg}#{id_lastmsg}">{lasttime}<br>{lastname}</a></div></td>
      </tr>';

      $stmt = mysqli_prepare($GLOBALS['DB'],
      'SELECT topics.id_topic, topics.type, topics.name, topics.id_lastuser, topics.lasttime, topics.id_lastmsg,
       topics.msgs, topics.views, topics.likes, b2.name, t1.id_item
       FROM topics
       LEFT JOIN users AS b2 ON topics.id_lastuser = b2.iduser
       LEFT JOIN newmsgs AS t1 ON topics.id_topic = t1.id_topic AND t1.iduser=?
       WHERE topics.deleted=0 AND topics.id_author=?
       ORDER BY topics.lasttime DESC
       LIMIT '."$ShowTopics".' OFFSET '."$Offset"); //берём все топики автора, сортируя от свежих к старым по последнему сообщению
      mysqli_stmt_bind_param($stmt, 'ii', intval($_COOKIE['iduser']), $id); 
      mysqli_stmt_execute($stmt);
      mysqli_stmt_bind_result($stmt, $id_topic, $type, $name, $id_lastuser, $lasttime, $id_lastmsg, $msgs, $views, $likes, $lastname, $isread);

      while (mysqli_stmt_fetch($stmt)){
        $row = $template; //копируем шаблон строки
  
        if ($isread > 0) $row = str_replace('{class}','CellsNewPost', $row);
        else $row = str_replace('{class}','CellsOldPost', $row);

        switch ($type){ //два типа топиков 1 - обычный, 2 - закрытый
          case 1: 
            $row = str_replace('{type}','<img src="./pics/common.png" alt="common" style="cursor:pointer" onclick="InvertMark({id_topic})" title="Обычный">', $row);
            break;
          case 2: 
            $row = str_replace('{type}','<img src="./pics/lock.png" alt="closed" style="cursor:pointer" onclick="InvertMark({id_topic})" title="Закрытый">', $row);
        }   
   
        $TotalMsgPages = ceil($msgs / $mpp); //узнаём нужно ли показывать маленький пейджитератор в названии топика
        if ($TotalMsgPages > 1){
          if ($TotalMsgPages < 5){ //если рисуем всё
            $smallpgi = ' (';
            for ($i = 1; $i <= $TotalMsgPages; $i++){
              if ($i < $TotalMsgPages){
                $smallpgi .= '<a href="./?ai=9&id={id_topic}&page='.$i.'">'.$i.'</a>, ';
              }else{
                $smallpgi .= '<a href="./?ai=9&id={id_topic}&page='.$i.'">'.$i.'</a>)';
              }
            }
          }else{//если ставим разрыв из троеточия
            $smallpgi = ' (<a href="./?ai=9&id={id_topic}&page=1">1</a>…';
            for ($i = $TotalMsgPages - 2; $i <= $TotalMsgPages; $i++){
              if ($i < $TotalMsgPages){
                $smallpgi .= '<a href="./?ai=9&id={id_topic}&page='.$i.'">'.$i.'</a>, ';
              }else{
                $smallpgi .= '<a href="./?ai=9&id={id_topic}&page='.$i.'">'.$i.'</a>)';
              }
            }
          }
        }else{
          $smallpgi = '';
        }
   
        $row = str_replace('{smallpgi}', $smallpgi, $row);
        $row = str_replace('{id_topic}', $id_topic, $row);
        $row = str_replace('{id}', $id, $row);
        $row = str_replace('{msgs}', $msgs, $row);
        $row = str_replace('{likes}', $likes, $row);
        $row = str_replace('{views}', $views, $row);
        $row = str_replace('{id_last}', $id_lastuser, $row);
        $row = str_replace('{id_lastmsg}', $id_lastmsg, $row);
        $row = str_replace('{lastname}', $lastname, $row);

        $date = date_create($lasttime); //для отображения смещаем время на указанное в настройках количество часов
        if ($timezone < 0){
          $timeshift = abs($timezone);
          date_sub($date, date_interval_create_from_date_string("$timeshift".' hours'));
        }else{
          date_add($date, date_interval_create_from_date_string("$timezone".' hours'));
        }
        $lasttime = date_format($date, $timeformat);
        $row = str_replace('{lasttime}', $lasttime, $row);

        $row = str_replace('{authname}', $authname, $row);
        $row = str_replace('{name}', $name, $row);
  
        $html .= $row;
      }
      mysqli_stmt_close($stmt);

      $html .= '</table><table cellspacing="0" cellpadding="0"><tr><td height="3px"></td></tr><tr>'.$PageIterator.'</tr></table>'.
      '<script>function InvertMark(id_topic){AsyncAct("ai=11&id="+encodeURIComponent(id_topic));}</script>'; // низ списка

    }else{ //если топиков нет
      $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
    <tr><td><div align="center">У "'.$authname.'" нет топиков.</div></td></tr><tr><td height="10px"></td></tr></table>'; 
    }

  }else{ //если такого участника нет
    $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
    <tr><td><div align="center">Такого участника нет.</div></td></tr><tr><td height="10px"></td></tr></table>';
  }

  return $html;
}
?>