<?php
require 'CountMail.php';
require 'GenerateCode.php';
function TryAddNewUser()
{
  if (!isset($_POST['name']) or //если что-то отсутствует, запускаем форму регистрации
      !isset($_POST['email']) or
      !isset($_POST['password']) or
      !isset($_POST['confirm']) or
      !isset($_POST['captcha']))
  {
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=1');
    else header('Location: http://'.$GLOBALS['HostName'].'/?ai=1');
    exit();
  }

  if (isset($_COOKIE['iduser']) and isset($_COOKIE['hash'])) //если юзер авторизован то вместо регистрации перенапраляем на начальную страницу
  {
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName']);
    else header('Location: http://'.$GLOBALS['HostName']);
    exit();
  }

  //Обрезаем переменные до длины, указанной в параметре maxlength тега input
  $name = substr($_POST['name'], 0, 100);
  $email = substr($_POST['email'], 0, 129);
  $password = substr($_POST['password'], 0, 100);
  $confirm = substr($_POST['confirm'], 0, 100);
  $captcha = substr($_POST['captcha'], 0, 5);
  // удаляем лишние символы
  $name = trim($name);
  $email = trim($email);
  $password = trim($password);
  $confirm = trim($confirm);
  $captcha = trim($captcha);
  // Проверяем все ошибки
  $error = '';
  if (empty($name)) $error .= '<li>Отображаемое имя не может быть пустым</li>'."\n";
  if (empty($email)) $error .= '<li>Адрес электронной почты не может быть пустым</li>'."\n"; 
  if (empty($password)) $error .= '<li>Пароль не может быть пустым</li>'."\n";
  if (empty($confirm)) $error .= '<li>Подтверждение пароля не может быть пустым</li>'."\n";
  if (empty($captcha)) $error .= '<li>Код капчи не может быть пустым</li>'."\n";
  if (!empty($password) and !empty($confirm) and $password!=$confirm) $error .= '<li>Пароли не совпадают</li>'."\n";
  //проверяем капчу
  if(md5($captcha) != $_COOKIE['imgcaptcha']) $error .= '<li>Код капчи неверный</li>'."\n";
  unset($_SESSION['captcha']);

  // проверка корректности e-mail
  $email = mb_strtolower($email); //приводим адрес почты к нижнему регистру
  if (!empty($email) and !preg_match("#^[0-9a-z_\-\.]+@[0-9a-z\-\.]+\.[a-z]{2,6}$#i", $email))
    $error .= '<li>Адрес электронной почты должен быть в формате name@host.xyz</li>'."\n";

   // проверка, на дубль email
   $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT iduser FROM users WHERE email=?');
   mysqli_stmt_bind_param($stmt, 's', $email);
   mysqli_stmt_execute($stmt);
   mysqli_stmt_store_result($stmt);
   $num = mysqli_stmt_num_rows($stmt);
   mysqli_stmt_close($stmt);
   if($num > 0) $error .= '<li>Этот адрес электронной почты уже занят</li>'."\n";

  // Если есть хотя бы одна ошибка - сохраняем в глобальном массиве введённые поля страницы регистрации и снова запускаем форму
  if (!empty($error)){
    $_SESSION['addNewUserForm'] = array();
    $_SESSION['addNewUserForm']['error'] = 'Были допущены ошибки:'."\n".'<ul>'."\n".$error.'</ul>'."\n";
    $_SESSION['addNewUserForm']['name'] = $name;
    $_SESSION['addNewUserForm']['email'] = $email;
    $_SESSION['addNewUserForm']['password'] = $password;
    $_SESSION['addNewUserForm']['confirm'] = $confirm;
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=1');
      else header('Location: http://'.$GLOBALS['HostName'].'/?ai=1');
    exit();
  }
  
  // код активации для отправки по Email
  $ALLOWED_CHARS = '0123456789';
  $code = '';
  mt_srand(hrtime()[1]);
  for ($i = 0; $i < 6; $i++) {
  $char = substr($ALLOWED_CHARS, mt_rand(0, strlen($ALLOWED_CHARS) - 1), 1);   
  $code .= $char;}// сохраняем накопительно код 

  $hash = md5(GenerateCode(10)); // генерируем случайную строку и шифруем её (хэш для куков авторизации, активации по email и смены пароля) 
  $md5password = md5(md5("$password")); //дважды шифруем пароль c принудительным приведением типов на случай если пароль только из цифр
  $regtime = date("Y-m-d H:i:s");
  // если все поля заполнены правильно - добавляем в базу нового участника
  $stmt = mysqli_prepare($GLOBALS['DB'], 'INSERT INTO users SET email=?, name=?, regtime=?, timevisit=?, emailcode=?, pass=?, user_hash=?');
  mysqli_stmt_bind_param($stmt, 'sssssss', $email, $name, $regtime, $regtime, $code, $md5password, $hash);
  mysqli_stmt_execute($stmt);
  mysqli_stmt_close($stmt);

  $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
  <tr><td><div align="center">{msg}</div></td></tr><tr><td height="10px"></td></tr></table>';

  $np = CountMail($email);//узнаём сколько всего отправлено писем на данный ящик за предыдущий час
  if ($np>9){ //ограничение на 10 писем в час
    $html = str_replace('{msg}', 'Превышен лимит по отправке писем на Ваш почтовый адрес за 1 час.<br>Попробуйте активацию позже через свою учётную запись.', $html);
  }else{
    $n = CountMail(); //узнаём сколько всего отправлено писем за предыдущий час
    if ($n>195){ // реальный лимит 200, но берём с запасом на всякий случай
      $html = str_replace('{msg}', 'Превышен лимит по отправке писем за 1 час.<br>Попробуйте активацию позже через свою учётную запись.', $html);
    }else{
      //готовим письмо для активации учётной записи
      $stremail = str_replace('@','<span>@</span>',$email); //чтобы адрес в письме оттображался как plain-text, без ссылки
      $stremail = str_replace('.','<span>.</span>',$email);

      $subject = 'Регистрация на форуме AGI.place'; 
      $headers = "From: AGI.place <mail@agi.place>\n";
      $headers .= "Content-type: text/html; charset=\"utf-8\"\n";
      $headers .= "Return-path: <mail@agi.place>\n";
      $message = 'Уважаемый(ая) <b>'.$name.'</b><br><br>'."\n";
      $message .= 'Для активации своей учётной записи введите данный код:<br><br>'."\n";
      $message .= '<b>'.$code.'</b><br><br>'."\n";
      $message .= 'С Уважением<br>'."\n";
      $message .= 'администратор форума AGI.place'."\n";

      if (!mail($email, $subject, $message, $headers)){
        $html = str_replace('{msg}', 'Что-то пошло не так.<br>Попробуйте активацию позже через свою учётную запись.', $html);
      }else{
        $html = file_get_contents('./templates/activateForm.html'); //загружаем шаблон формы активации   
        $html = str_replace('{iduser}', $hash, $html);
        $html = str_replace('{action}', 'TryActivateEmail.php', $html);
        $html = str_replace('{error}', '', $html);
        $text = '<br>Регистрация прошла успешно.<br>'.
        'Для активации учётной записи введите код, отправленный Вам по электронной почте.<br>'.
        'Либо перейдите по ссылке в полученном письме.';
        $html = str_replace('{text}', $text, $html);
      }

      $sendtime = date('Y-m-d H:i:s'); //добавляем в базу для подсчёта отправленных писем
      $stmt = mysqli_prepare($GLOBALS['DB'], 'INSERT INTO mailcounter SET email=?, sendtime=?');
      mysqli_stmt_bind_param($stmt, 'ss', $email, $sendtime);
      mysqli_stmt_execute($stmt);
      mysqli_stmt_close($stmt);
    }
  }
  return $html;
}
?>