<?php
require 'const.php';
session_start();

if (!isset($_POST['id_topic']) or //если что-то отсутствует либо юзер неавторизован, запускаем заглавную страницу
    !isset($_POST['message']) or
    !isset($_COOKIE['iduser']) or
    !isset($_COOKIE['hash']))
{
  if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName);
  else header('Location: http://'.$HostName);
  exit();
}

$iduser = intval($_COOKIE['iduser']);
$idtopic = (int)substr(strval($_POST['id_topic']), 0, 7);

$DB = mysqli_connect($DBhost, $DBuser, $DBpwd);
if ($DB !== false){
  mysqli_select_db($DB, $DBname);

  $stmt = mysqli_prepare($DB, 'SELECT user_hash FROM users WHERE iduser=? LIMIT 1');
  mysqli_stmt_bind_param($stmt, 'i', $iduser);
  mysqli_stmt_execute($stmt);
  mysqli_stmt_bind_result($stmt, $user_hash);
  mysqli_stmt_fetch($stmt);
  mysqli_stmt_close($stmt);
  if ($user_hash !== $_COOKIE['hash']){ //если хэши не совпадают
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName']);
    else header('Location: http://'.$GLOBALS['HostName']);
    exit();
  } 

  $stmt = mysqli_prepare($DB, 'SELECT id_author, type, deleted FROM topics WHERE id_topic=? LIMIT 1'); //проверяем есть ли топик
  mysqli_stmt_bind_param($stmt, 'i', $idtopic);
  mysqli_stmt_execute($stmt);
  mysqli_stmt_bind_result($stmt, $id_author, $type, $del); //данные топика
  mysqli_stmt_fetch($stmt);
  mysqli_stmt_close($stmt);
  if (!isset($id_author)){
    $_SESSION['msg'] = 'Такого топика нет.';
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=200');
    else header('Location: http://'.$GLOBALS['HostName'].'/?ai=200');
    exit();
  }

  if ($del == 1){
    $_SESSION['msg'] = 'Топик удалён.';
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=200');
    else header('Location: http://'.$GLOBALS['HostName'].'/?ai=200');
    exit();
  }

  $stmt = mysqli_prepare($DB, 'SELECT status, deleted FROM users WHERE iduser=? LIMIT 1');
  mysqli_stmt_bind_param($stmt, 'i', $iduser);
  mysqli_stmt_execute($stmt);
  mysqli_stmt_bind_result($stmt, $status, $deleted);// данные пользователя
  mysqli_stmt_fetch($stmt);
  mysqli_stmt_close($stmt);

  if (($status == 'readonly') or ($deleted == 1)){ //нельзя создавать сообщения нигде со статусом readonly/deleted
    $_SESSION['msg'] = 'Ваш статус не позволяет создавать сообщения на форуме.';
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=200');
    else header('Location: http://'.$GLOBALS['HostName'].'/?ai=200');
    exit();
  }

  if ($id_author != $iduser){
    $stmt = mysqli_prepare($DB, 'SELECT listid FROM wblist WHERE id_from=? AND id_to=? LIMIT 1');
    mysqli_stmt_bind_param($stmt, 'ii', $id_author, $iduser);
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $listid); // данные ч/б списков
    mysqli_stmt_fetch($stmt);
    mysqli_stmt_close($stmt);
  }else{
    $listid = 1; //мы сами у себя всегда в белом списке
  }

  if($listid == -1){ //нельзя создавать сообщения в топиках, где мы в чёрном списке
    $_SESSION['msg'] = 'Автор топика запретил Вам создавать сообщения.';
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=200');
    else header('Location: http://'.$GLOBALS['HostName'].'/?ai=200');  
    exit();
  }

  if (($type == 2) and ($status != 'readonly') and ($listid != 1)){//нельзя создавать сообщения в закрытых топиках если мы не в белом списке
    $_SESSION['msg'] = 'Автор топика не разрешил Вам создавать сообщения.';
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=200');
    else header('Location: http://'.$GLOBALS['HostName'].'/?ai=200');
    exit();
  }

//обрезаем переменные по длине и проверяем все ошибки
  $error = '';
  $message = $_POST['message'];
  $testmsg = trim($message);
  
  if (empty($testmsg)) $error .= '<li>Текст сообщения не может быть пустым</li>'."\n";
  if (strlen($message)>100000) $error .= '<li>Текст сообщения не может превышать 50000 символов</li>'."\n";
 
  // Если есть хотя бы одна ошибка - сохраняем в глобальном массиве введённые поля и снова запускаем форму
  if (!empty($error)){
    $_SESSION['NewMsgForm'] = array();
    $_SESSION['NewMsgForm']['error'] = 'Были допущены ошибки:'."\n".'<ul>'."\n".$error.'</ul>'."\n";
    $_SESSION['NewMsgForm']['message'] = $message;

    mysqli_close($DB);
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=10&id='."$idtopic");
    else header('Location: http://'.$HostName.'/?ai=10&id='."$idtopic");
    exit();
  }
 
  // если все поля заполнены правильно - создаём новое сообщение в топике
  $createtime = date('Y-m-d H:i:s');
  $stmt = mysqli_prepare($DB, 'INSERT INTO posts SET id_author=?, id_topic=?, text=?, createtime=?');
  mysqli_stmt_bind_param($stmt, 'iiss', $iduser, $idtopic, $message, $createtime);
  mysqli_stmt_execute($stmt);
  $dber = mysqli_stmt_error($stmt);
  mysqli_stmt_close($stmt);
  $id_post = mysqli_insert_id($DB); //id нового поста

  if (empty($dber)){
    $stmt = mysqli_prepare($DB, 'UPDATE topics SET id_lastmsg=?, id_lastuser=?, lasttime=?, msgs = msgs + 1 WHERE id_topic=?'); //обновляем данные топика
    mysqli_stmt_bind_param($stmt, 'iisi', $id_post, $iduser, $createtime, $idtopic);
    mysqli_stmt_execute($stmt);
    $dber2 = mysqli_stmt_error($stmt);
    mysqli_stmt_close($stmt);

    if (empty($dber2)){
      $stmt = mysqli_prepare($DB, 'UPDATE users SET posts=posts+1 WHERE iduser=?'); //обновляем данные участника
      mysqli_stmt_bind_param($stmt, 'i', $iduser);
      mysqli_stmt_execute($stmt);
      $dber3 = mysqli_stmt_error($stmt);
      mysqli_stmt_close($stmt);

      $stmt = mysqli_prepare($DB, 'SELECT iduser FROM newmsgs WHERE id_topic=?'); //создаём список исключений (если запись есть, значит участник не читал топик)
      mysqli_stmt_bind_param($stmt, 'i', $idtopic);
      mysqli_stmt_execute($stmt);
      mysqli_stmt_bind_result($stmt, $id_u);
      mysqli_stmt_store_result($stmt);
      $num = mysqli_stmt_num_rows($stmt);
      if ($num == 0){
        $exep = '';
      }else{
        $exep = ' WHERE iduser NOT IN('; 
        while (mysqli_stmt_fetch($stmt)){
          $num = $num - 1;
          if ($num > 0) $exep .= "$id_u".',';
          else $exep .= "$id_u".') '; //последний элемент завершаем скобкой а не запятой
        }
      }
      mysqli_stmt_close($stmt);

      $stmt = mysqli_prepare($DB, 'INSERT INTO newmsgs (id_topic, iduser) SELECT ?, iduser FROM users'.$exep);//записываем индикаторы просмотров без лишних
      mysqli_stmt_bind_param($stmt, 'i', $idtopic);
      mysqli_stmt_execute($stmt); 
      mysqli_stmt_close($stmt);
    }
  }
  mysqli_close($DB);

  if (empty($dber) and empty($dber2) and empty($dber3)){ //если добавление в базу произошло без ошибок
    //переходим в топик на созданное сообщение
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=9&msg='."$id_post".'#'."$id_post");
    else header('Location: http://'.$HostName.'/?ai=9&msg='."$id_post".'#'."$id_post");
  }else{ //иначе показываем ошибки
    $_SESSION['msg'] = 'Ошибка базы данных: '.$dber.' '.$dber2.' '.$dber3;
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=200');
    else header('Location: http://'.$HostName.'/?ai=200');
  }
}else{
  $_SESSION['msg'] = 'Ошибка соединения с базой данных: '.mysqli_connect_error();
  if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=200');
  else header('Location: http://'.$HostName.'/?ai=200');
}
?>