<?php
require 'const.php';
session_start();

if (!isset($_COOKIE['iduser']) or !isset($_COOKIE['hash'])){ //если юзер не авторизован, то перенаправляем на начальную страницу
  if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName']);
  else header('Location: http://'.$GLOBALS['HostName']);
  exit();
}

if (!isset($_POST['id_to'])){ //если отсутствует получатель, запускаем список участников
  if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=51');
  else header('Location: http://'.$GLOBALS['HostName'].'/?ai=51');
  exit();
}

$DB = mysqli_connect($DBhost, $DBuser, $DBpwd);
if ($DB !== false){
  mysqli_select_db($DB, $DBname);

  $stmt = mysqli_prepare($DB, 'SELECT user_hash FROM users WHERE iduser=? LIMIT 1');
  mysqli_stmt_bind_param($stmt, 'i', intval($_COOKIE['iduser']));
  mysqli_stmt_execute($stmt);
  mysqli_stmt_bind_result($stmt, $user_hash);
  mysqli_stmt_fetch($stmt);
  mysqli_stmt_close($stmt);

  if ($user_hash !== $_COOKIE['hash']){ //если хэши не совпадают
    mysqli_close($DB);
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName); // перенаправляем на начальную страницу
    else header('Location: http://'.$HostName);
    exit();
  }

  $id_to = substr($_POST['id_to'], 0, 6);
  $topic = substr($_POST['topic'], 0, 300);
  $mes = substr($_POST['message'], 0, 30000);
  $test = trim($mes);

  // Проверяем все ошибки
  $error = '';

  $stmt = mysqli_prepare($DB, 'SELECT id_item FROM wblist WHERE id_from=? AND id_to=? AND listid=-1 LIMIT 1');
  mysqli_stmt_bind_param($stmt, 'ii', $id_to, intval($_COOKIE['iduser']));
  mysqli_stmt_execute($stmt);
  mysqli_stmt_store_result($stmt);
  $num = mysqli_stmt_num_rows($stmt);
  mysqli_stmt_close($stmt);
  if($num > 0) $error .= '<li>Участник запретил Вам отправлять сообщения</li>'."\n";

  if (empty($test)) $error .= '<li>Сообщение не может быть пустым</li>'."\n";

   // если есть хотя бы одно отклонение от нормы, снова запускаем форму но с сообщением
  if (!empty($error)){
    $_SESSION['PMForm'] = array();
    $_SESSION['PMForm']['error'] = 'Были допущены ошибки:'."\n".'<ul>'."\n".$error.'</ul>'."\n";
    $_SESSION['PMForm']['topic'] = $topic;
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=20&id='.$id_to);
      else header('Location: http://'.$GLOBALS['HostName'].'/?ai=20&id='.$id_to);
    exit();
  }
  
  //достаём значение индикатора об уведомлении на почту, имя и саму почту
  $stmt = mysqli_prepare($DB, 'SELECT name, email, mailpmnotice FROM users WHERE iduser=? LIMIT 1');
  mysqli_stmt_bind_param($stmt, 'i', $id_to);
  mysqli_stmt_execute($stmt);
  mysqli_stmt_bind_result($stmt, $name, $email, $mailpmnotice); 
  mysqli_stmt_fetch($stmt);
  mysqli_stmt_close($stmt);

  if ($mailpmnotice == 1){ //если пользователь разрешил отправлять себе уведомления по email
    require 'CountMail.php';
    $np = CountMail($email);//проверяем сколько всего отправлено писем на данный ящик за предыдущий час
    if ($np<4){ //ограничение здесь на 4 письма в час
      $n = CountMail(); //проверяем сколько всего отправлено писем за предыдущий час
      if ($n<195){ // реальный лимит 200, но берём здесь с запасом на всякий случай
        //готовим письмо-уведомление
        $subject = 'Новое личное сообщение на AGI.place';   
        $headers = "From: AGI.place <mail@agi.place>\n";
        $headers .= "Content-type: text/html; charset=\"utf-8\"\n";
        $headers .= "Return-path: <mail@agi.place>\n";
        $message = 'Уважаемый(ая) <b>'.$name.'</b><br><br>'."\n";
        $message .= 'Участник <b>'.$_SESSION['username'].'</b> прислал Вам личное сообщение.<br>'."\n";
        $message .= 'Для просмотра сообщения перейдите по ссылке:<br>'."\n";
        $link = 'http://'.$GLOBALS['HostName'].'/?ai=22';
        $message .= '<a href="'.$link.'">'.$link.'</a><br><br>'."\n";
        $message .= 'С Уважением<br>'."\n";
        $message .= 'администратор форума AGI.place'."\n";

        if (mail($email, $subject, $message, $headers)){  
          $sendtime = date('Y-m-d H:i:s'); //добавляем в базу для подсчёта отправленных писем
          $stmt = mysqli_prepare($DB, "INSERT INTO mailcounter SET email=?, sendtime=?");
          mysqli_stmt_bind_param($stmt, "ss", $email, $sendtime);
          mysqli_stmt_execute($stmt);
          mysqli_stmt_close($stmt);
        }
      }
    }    
  }

  $sendtime = date('Y-m-d H:i:s'); 
  $stmt = mysqli_prepare($DB, 'INSERT INTO pm SET id_to=?, id_from=?, topic=?, message=?, sendtime=?');
  mysqli_stmt_bind_param($stmt, 'iisss', $id_to, $_COOKIE['iduser'], $topic, $mes, $sendtime);
  mysqli_stmt_execute($stmt);
  $dber = mysqli_stmt_error($stmt);
  mysqli_stmt_close($stmt);

  if (empty($dber)) {//уведомляем через ai=200 чтобы при обновлении страницы не отправилось ещё одно сообщение
    $_SESSION['msg'] = 'Сообщение успешно отправлено.';
  }else{
    $_SESSION['msg'] = 'Произошла ошибка: '.$dber;
  }
  mysqli_close($DB);
}else{
  $_SESSION['msg'] = 'Ошибка соединения с базой данных: '.mysqli_connect_error();
}

  if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=200');
  else header('Location: http://'.$HostName.'/?ai=200');
?>