<?php
require 'CountSMS.php';
function TrySendSMS()
{
  if (!$GLOBALS['islogged'] or !isset($_COOKIE['iduser']) or !isset($_COOKIE['hash'])){ //если юзер не авторизован, то  перенаправляем на начальную страницу
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName']);
    else header('Location: http://'.$GLOBALS['HostName']);
    exit();
  }

  if (!isset($_POST['phone'])){ //если телефон отсутствует, то запускаем форму
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=6');
    else header('Location: http://'.$GLOBALS['HostName'].'/?ai=6');
    exit();
  }

  $phone = substr($_POST['phone'], 0, 20); //обрезаем переменную по длине
  $phone = preg_replace('/[^0-9]/', '', $phone); // удаляем всё кроме цифр

  // Проверяем все ошибки
  $error = '';
  if (empty($phone)) $error .= '<li>Номер телефона не может быть пустым</li>'."\n";

  $regexp = '/^\+?([87](?!95[5-79]|99[08]|907|94[^0]|336)([348]\d|9[0-6789]|7[01247])\d{8}|[1246]\d{9,13}|68\d{7}|5[1-46-9]\d{8,12}|55[1-9]\d{9}|55[138]\d{10}'.
  '|55[1256][14679]9\d{8}|554399\d{7}|500[56]\d{4}|5016\d{6}|5068\d{7}|502[45]\d{7}|5037\d{7}|50[4567]\d{8}|50855\d{4}|509[34]\d{7}|376\d{6}|855\d{8,9}'.
  '|856\d{10}|85[0-4789]\d{8,10}|8[68]\d{10,11}|8[14]\d{10}|82\d{9,10}|852\d{8}|90\d{10}|96(0[79]|17[0189]|181|13)\d{6}|96[23]\d{9}|964\d{10}'.
  '|96(5[569]|89)\d{7}|96(65|77)\d{8}|92[023]\d{9}|91[1879]\d{9}|9[34]7\d{8}|959\d{7,9}|989\d{9}|971\d{8,9}|97[02-9]\d{7,11}|99[^4568]\d{7,11}'.
  '|994\d{9}|9955\d{8}|996[2579]\d{8}|9989\d{8}|380[345679]\d{8}|381\d{9}|38[57]\d{8,9}|375[234]\d{8}|372\d{7,8}|37[0-4]\d{8}|37[6-9]\d{7,11}'.
  '|30[69]\d{9}|34[679]\d{8}|3459\d{11}|3[12359]\d{8,12}|36\d{9}|38[169]\d{8}|382\d{8,9}|46719\d{10})$/'; //для всех стран

  $phone = '+'.$phone; //окончательно формируем номер телефона

  if (!preg_match($regexp, $phone)) $error .= '<li>Формат номера неверный</li>'."\n";

  // проверка на повторное использование номера телефона
  $phonemd5 = md5(md5("$phone")); //в базе хранятся только двойные хэши
  $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT iduser FROM users WHERE phone=? AND smscode=1'); //ищем только активированных участников
  mysqli_stmt_bind_param($stmt, 's', $phonemd5);
  mysqli_stmt_execute($stmt);
  mysqli_stmt_store_result($stmt);
  $num = mysqli_stmt_num_rows($stmt);
  mysqli_stmt_close($stmt);
  if ($num > 0) $error .= '<li>Этот телефонный номер уже использован для активации</li>'."\n";

  // проверка на попытку повторной активации, также заодно достаём из базы IP
  $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT smscode, user_ip FROM users WHERE user_hash=? LIMIT 1');
  mysqli_stmt_bind_param($stmt, 's', $_COOKIE['hash']);
  mysqli_stmt_execute($stmt);
  mysqli_stmt_bind_result($stmt, $codeDB, $user_ip);
  mysqli_stmt_fetch($stmt);
  mysqli_stmt_close($stmt);
  if ($codeDB == '1') $error .= '<li>Учётная запись уже активирована по SMS</li>'."\n";

  //с одного IP, аккаунта и телефона разрешаем отправить не более 2-х смс в сутки. выбирается максимальный ограничитель.
  $np = CountSMS($user_ip, $_COOKIE['hash'], $phonemd5);//узнаём сколько всего отправлено SMS за сутки для данного номера/юзера/IP
  if ($np >= 2) $error .= '<li>Превышен лимит по отправке SMS в сутки. Попробуйте активацию позже.</li>'."\n";

   // если есть хотя бы одно отклонение от нормы, снова запускаем форму но с сообщением
  if (!empty($error)){
    $_SESSION['SMSActFormError'] = 'Были допущены ошибки:'."\n".'<ul>'."\n".$error.'</ul>'."\n";
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=6');
      else header('Location: http://'.$GLOBALS['HostName'].'/?ai=6');
    exit();
  }
  
  // код активации для отправки по SMS
  $ALLOWED_CHARS = '0123456789';
  $code = '';
  mt_srand(hrtime()[1]);
  for ($i = 0; $i < 6; $i++){
  $char = substr($ALLOWED_CHARS, mt_rand(0, strlen($ALLOWED_CHARS) - 1), 1);   
  $code .= $char;}// сохраняем накопительно код 

  $stmt = mysqli_prepare($GLOBALS['DB'], 'UPDATE users SET smscode=?, phone=? WHERE user_hash=?');
  mysqli_stmt_bind_param($stmt, 'sss', $code, $phonemd5, $_COOKIE['hash']);
  mysqli_stmt_execute($stmt);
  mysqli_stmt_close($stmt);

  include_once "smsc_api.php";
  $r = send_sms($phone, 'AGIcode: '."$code"); // $r = array(<id>, <количество sms>, <стоимость>, <баланс>) или array(<id>, -<код ошибки>)

  if ($r[1] > 0){ //сообщение успешно отправлено
  $sendtime = date('Y-m-d H:i:s'); //добавляем в базу для подсчёта отправленных SMS
  $stmt = mysqli_prepare($GLOBALS['DB'], 'INSERT INTO smscounter SET phone=?, user_hash=?, user_ip=?, sendtime=?');
  mysqli_stmt_bind_param($stmt, 'ssss', $phonemd5, $_COOKIE['hash'], $user_ip, $sendtime);
  mysqli_stmt_execute($stmt);
  mysqli_stmt_close($stmt);

  $html = file_get_contents('./templates/activateForm.html'); //загружаем шаблон формы активации   
  $html = str_replace('{iduser}', '', $html);
  $html = str_replace('{action}', 'TryActivateSMS.php', $html);
  $html = str_replace('{error}', '', $html);
  $html = str_replace('{text}', '<br>Для активации учётной записи введите код, отправленный Вам по SMS.', $html);
  }else{// при отправке произошла ошибка
  $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
  <tr><td><div align="center">Произошла ошибка № '.-$r[1].'<br>Попробуйте активацию позже.</div></td></tr><tr><td height="10px"></td></tr></table>';
  }
 return $html;
}
?>