<?php
  $topicid = (int)substr($_GET['id'], 0, 6); // id топика
  if ($topicid > 0){
    require 'const.php';
    $DB = mysqli_connect($DBhost, $DBuser, $DBpwd);
    if ($DB !== false){
      mysqli_select_db($DB, $DBname);

      $stmt = mysqli_prepare($DB, 'SELECT msgs, name, deleted FROM topics WHERE id_topic=?');
      mysqli_stmt_bind_param($stmt, 'i', $topicid); 
      mysqli_stmt_execute($stmt);
      mysqli_stmt_bind_result($stmt, $Totalmsgs, $name, $del); // получение количества сообщений всего, названия и проверка есть ли топик
      mysqli_stmt_fetch($stmt);
      mysqli_stmt_close($stmt);
      if (($del == 1) or empty($name)) {//если топик удалён или отсутствует
        $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
        <tr><td><div align="center">Такого контента нет.</div></td></tr><tr><td height="10px"></td></tr></table>';
        echo $html;
        exit(); 
      }

      require 'TagFormat.php';
      if (isset($_COOKIE['iduser']) and isset($_COOKIE['hash'])){ //если куки авторизации есть берём настройки отображения контента
        $stmt = mysqli_prepare($DB, 'SELECT timezone, timeformat FROM users WHERE user_hash=? LIMIT 1');
        mysqli_stmt_bind_param($stmt, 'i', $_COOKIE['hash']); 
        mysqli_stmt_execute($stmt);
        mysqli_stmt_bind_result($stmt, $timezone, $timeformat);
        mysqli_stmt_fetch($stmt);
        mysqli_stmt_close($stmt);
      }else{ // если гостевой доступ
        $timezone = (int)$_COOKIE['timeshift']; // пробуем взять данные из куков
        if (($timezone < -12) or ($timezone > 12)) $timezone = 0;
        $timeformat = 'H:i d.m.Y';
      }

      $css = file_get_contents('./main.css');
      $imageData = base64_encode(file_get_contents('./pics/favicon.ico'));

      $html = '<!DOCTYPE html><html><head><meta charset="utf-8"><title>AGI.place - '.$name.'</title><meta name="viewport" content="width=830">'.
      '<link href="data:image/x-icon;base64,'.$imageData.'" rel="icon" type="image/x-icon" />'.
      '<style type="text/css">'.$css.'</style></head>'.
      '<body>{avatar_data}<table align="center" cellpadding="0" cellspacing="0" width="810"><tr><td>';
    
      //заголовок страницы
      $html .= '<table cellspacing="0" cellpadding="0" width="100%" style="background-color: #f5f5f5; font-size: 16px; font-weight: 600">
      <tr style="background-color: #98c6d2"><td height="1px"></td></tr><tr><td height="10px"></td></tr>
      <tr><td><div title="Название топика" align="center">'.$name.'</div></td></tr><tr><td height="12px"></td></tr></table>';
    
      $html .= '<table width="100%" cellspacing="0" cellpadding="0">
      <tr style="background-color: #98c6d2"><td colspan="2" height="1px"></td></tr>'; //начало таблицы сообщений
    
      //шаблон строки таблицы
      $template = '<tr><td><a name="{id_msg}"></a></td></tr>{hidebut}
      <tr {hidestyle}><td width="15%" valign="top" align="center">
        <div style="min-height: 21px; display: table"><p style="display: table-cell; vertical-align: bottom">
        <a title="Перейти на страницу участника" style="font-size: 15px; font-weight: 600" href="https://'.$HostName.'/?ai=50&id={id}">{name}</a></p></div>
        {avatar}
      </td>
      <td width="85%">
        <div><table width="100%" height="21px" cellspacing="0" cellpadding="0"><tr style="background: #e5e5e5">
        <td width="17%" align="middle"><span title="Время создания" style="font-size:12px;color:#585858">{createtime}</span></td>
        <td width="1%"></td>
        <td width="17%"><span title="Время правки" style="font-size: 12px;color:#585858">{edittime}</span></td>
        <td width="45%"></td>
        <td width="20%" align="right"><a title="Ссылка на сообщение" style="padding-right:4px;font-size:14px" href="https://'.$HostName.'/?ai=9&msg={id_msg}#{id_msg}">№{id_msg}</a></td>
        </tr></table></div>
        <div class="message">{message}</div>
      </td></tr>
      <tr style="background-color: #98c6d2"><td colspan="2" height="1px"></td></tr>';
    
      $bl = array(); // строим чёрный список
      $stmt = mysqli_prepare($DB, 'SELECT id_to FROM wblist WHERE id_from=? AND listid=-1');
      mysqli_stmt_bind_param($stmt, 'i', intval($_COOKIE['iduser']));
      mysqli_stmt_execute($stmt);
      mysqli_stmt_bind_result($stmt, $id_to);
      while (mysqli_stmt_fetch($stmt)){
        array_push($bl, $id_to);
      }
      mysqli_stmt_close($stmt);

      $avatar_counter = array(); //массив для запоминания количества аватаров
      $avatar_number = array(); //массив для запоминания номера аватара
      $avatar_data = ''; //переменная для хранения base64 копий аватаров
    
      $stmt = mysqli_prepare($DB,
      'SELECT posts.id_msg, posts.createtime, posts.edittime, posts.text, posts.id_author, users.name, users.avatar
       FROM posts
       LEFT JOIN users ON posts.id_author = users.iduser
       WHERE posts.id_topic=? AND posts.deleted=0
       ORDER BY posts.id_msg ASC'); //берём все сообщения топика, сортируя от свежих к старым
      mysqli_stmt_bind_param($stmt, 'i', $topicid);
      mysqli_stmt_execute($stmt);
      mysqli_stmt_bind_result($stmt, $id_msg, $createtime, $edittime, $text, $id_author, $username, $avatar);
    
      while (mysqli_stmt_fetch($stmt)){
        $row = $template; //копируем шаблон строки
    
        $row = str_replace('{id}',$id_author, $row);
        $row = str_replace('{id_msg}',$id_msg, $row);
    
        $date = date_create($createtime); //для отображения смещаем время на указанное в настройках количество часов
        if ($timezone < 0){
          $timeshift = abs($timezone);
          date_sub($date, date_interval_create_from_date_string("$timeshift".' hours'));
        }else{
          date_add($date, date_interval_create_from_date_string("$timezone".' hours'));
        }
        $createtime = date_format($date, $timeformat);
        $row = str_replace('{createtime}',$createtime, $row);
    
        if ($edittime != '0000-00-00 00:00:00'){
          $date = date_create($edittime); //для отображения смещаем время на указанное в настройках количество часов
          if ($timezone < 0){
            $timeshift = abs($timezone);
            date_sub($date, date_interval_create_from_date_string("$timeshift".' hours'));
          }else{
            date_add($date, date_interval_create_from_date_string("$timezone".' hours'));
          }
          $edittime = date_format($date, $timeformat);
          $row = str_replace('{edittime}',$edittime, $row);
        }else{
          $row = str_replace('{edittime}','', $row);
        }
    
        if (!empty($avatar)){ //если аватар есть
          if (isset($avatar_counter[$avatar])){ //если такой аватар уже был
            $avatar_counter[$avatar]++;
          }else{ //если аватар встречается впервые
            $avatar_counter[$avatar] = 0;
            $avatar_number[$avatar] = count($avatar_counter) - 1;
            $imageData = base64_encode(file_get_contents('./avatars/'.$avatar.'.jpg'));
            $avatar_data .= '<div id="img'.$avatar_number[$avatar].'" style="display: none;"><img src="data:image/gif;base64,'.$imageData.'"/></div>';
          }
          $avatar_html='<div id="id'.$avatar_number[$avatar].$avatar_counter[$avatar].'" style="margin-top: 5px"></div>';
        }else{ // если аватара нет
          $avatar_html='';
        }
        $row = str_replace('{avatar}', $avatar_html, $row);

        if (in_array($id_author, $bl, true)){ // если автор в чёрном списке - скрываем его сообщение
          $hidebut = '<tr><td colspan="2"><div width="100%"><input type="button" id="idbut'.$id_msg.'" style="width:70px;display:inline-block;margin-left: 19px;"
           value="Показать" onclick="ShowHide('.$id_msg.', this.id)"> &nbsp; сообщение от '.$username.'</div></td></tr>';
          $row = str_replace('{hidebut}', $hidebut, $row);
          $row = str_replace('{hidestyle}', 'style="background-color: #d5d5d5;display:none" id='.$id_msg, $row);
        }else{
          $row = str_replace('{hidebut}', '', $row);
          $row = str_replace('{hidestyle}', 'style="background-color: #f5f5f5"', $row);
        }
    
        $row = str_replace('{name}',$username, $row);
        $row = str_replace('{message}', TagFormat($text), $row); //выводим имя и сообщение со всеми тэгами в конце, чтобы исключить риски замены данных в тексте сообщения (например, если юзер напишет {niz})
    
        $html .= $row;
      }
      mysqli_stmt_close($stmt);
      mysqli_close($DB);

      $html = str_replace('{avatar_data}',$avatar_data, $html); //вносим base64 данные всех аватаров

      $avatars=''; // фдфптируем скрипт, заполняющий аватары при старте
      foreach ($avatar_counter as $col){
        $avatars .= "$col".',';
      }
      $avatars = mb_substr($avatars, 0, -1); //удаляем последнюю запятую

      $html .= '</table>
      <script>
      document.onload = LoadAvatars();
      function LoadAvatars(){
      let pics = ['.$avatars.'];
      for (var j = 0; j < '.count($avatar_counter).'; j++){
      for (var i = 0; i <= pics[j]; i++){document.getElementById("id"+j+i).innerHTML =  document.getElementById("img"+j).innerHTML;}}}
      function ShowHide(id,idbut){if(document.getElementById(id).style.display == "none"){'.
      'document.getElementById(id).style.display = ""; document.getElementById(idbut).value = "Скрыть";'.
      '}else{document.getElementById(id).style.display = "none"; document.getElementById(idbut).value = "Показать";};}
      </script></td></tr></table></body></html>';

      header('Content-Description: File Transfer');
      header('Content-Type: application/octet-stream');
      header('Content-Disposition: attachment; filename=Topic_'.$topicid.'.html');
      header('Content-Transfer-Encoding: binary');
      header('Content-Length: '.strlen($html));
      echo $html;
    }  
  }
?>